<?php
// file is being called directly.
if (false === defined('ABSPATH')) {
  exit;
}
?>
<table>
  <tbody>
    <tr>
      <td><label for="url"><?= __('URL:', 'ekl_rss_feed_reader'); ?></label></td>
      <td>
        <input type="text" id="ekl_rss_url" name="ekl_rss_url" value="<?= $url; ?>" class="regular-text" maxlength="255" />
        <button type="button" class="button" id="ekl_rss_check_url_button" <?php if (empty($url)): ?>disabled="disabled"<?php endif; ?>>
          <?= __('Check URL', 'ekl_rss_feed_reader'); ?>
        </button>
        <img src="<?= includes_url('images/spinner.gif'); ?>" alt="" class="spinner" id="ekl_rss_check_url_spinner" />
      </td>
    </tr>
    <tr>
      <td></td>
      <td>
        <div class="error-message"><em id="ekl_rss_url_error"></em></div>
      </td>
    </tr>
    <tr>
      <td><label for="ekl_rss_entries_count"><?= __('Max entries count:', 'ekl_rss_feed_reader'); ?></label></td>
      <td><input type="text" id="ekl_rss_entries_count" name="ekl_rss_entries_count" value="<?= $entries_count; ?>" size="4" maxlength="2" /></td>
    </tr>
    <tr>
      <td><label for="ekl_rss_update_interval"><?= __('Update interval:', 'ekl_rss_feed_reader'); ?></label></td>
      <td>
        <select name="ekl_rss_update_interval" id="ekl_rss_update_interval">
          <?php foreach (ekl_rss_get_rss_update_intervals() as $interval => $label): ?>
            <option value="<?= $interval; ?>" <?php if ($update_interval == $interval): ?>selected="selected"<?php endif; ?>><?= $label; ?></option>
          <?php endforeach; ?>
        </select>
        <span><?= __('counting from midnight', 'ekl_rss_feed_reader'); ?></span>
      </td>
    </tr>
    <tr>
      <td><label for="ekl_rss_entry_picture_source"><?= __('Entry picture source:', 'ekl_rss_feed_reader'); ?></label></td>
      <td>
        <select name="ekl_rss_entry_picture_source" id="ekl_rss_entry_picture_source">
          <?php foreach (ekl_rss_get_rss_item_image_sources() as $source => $label): ?>
            <option value="<?= $source; ?>" <?php if ($source === $entry_picture_source): ?>selected="selected"<?php endif; ?>><?= $label; ?></option>
          <?php endforeach; ?>
        </select>
      </td>
    </tr>
    <tr <?php if ($entry_picture_source !== 'tag_index'): ?>style="display:none"<?php endif; ?> class="_check_ekl_rss_entry_picture_source _show_if_tag_index">
      <td><label for="ekl_rss_entry_picture_tag"><?= __('Tag name:', 'ekl_rss_feed_reader'); ?></label></td>
      <td><input type="text" id="ekl_rss_entry_picture_tag" name="ekl_rss_entry_picture_tag" value="<?= $entry_picture_tag; ?>" maxlength="64" class="regular-text" /></td>
    </tr>
    <tr <?php if ($entry_picture_source !== 'tag_index'): ?>style="display:none"<?php endif; ?> class="_check_ekl_rss_entry_picture_source _show_if_tag_index">
      <td><label for="ekl_rss_entry_picture_index"><?= __('Tag index:', 'ekl_rss_feed_reader'); ?></label></td>
      <td><input type="text" id="ekl_rss_entry_picture_index" name="ekl_rss_entry_picture_index" value="<?= $entry_picture_index; ?>" size="4" maxlength="4" /></td>
    </tr>
    <tr <?php if ($entry_picture_source !== 'xpath'): ?>style="display:none"<?php endif; ?> class="_check_ekl_rss_entry_picture_source _show_if_xpath">
      <td><label for="ekl_rss_entry_picture_xpath"><?= __('Tag XPath:', 'ekl_rss_feed_reader'); ?></label></td>
      <td><input type="text" id="ekl_rss_entry_picture_xpath" name="ekl_rss_entry_picture_xpath" value="<?= $entry_picture_xpath; ?>" class="regular-text" /></td>
    </tr>
    <tr>
      <td><label for="ekl_rss_entry_picture_tag_attribute"><?= __('Tag attribute:', 'ekl_rss_feed_reader'); ?></label></td>
      <td><input type="text" id="ekl_rss_entry_picture_tag_attribute" name="ekl_rss_entry_picture_tag_attribute" value="<?= $entry_picture_tag_attribute; ?>" class="regular-text" maxlength="64" /></td>
    </tr>
    <tr>
      <td><label for="ekl_rss_entry_picture_attribute_extractor"><?= __('Attribute content extractor:', 'ekl_rss_feed_reader'); ?></label></td>
      <td>
        <select name="ekl_rss_entry_picture_attribute_extractor" id="ekl_rss_entry_picture_attribute_extractor">
          <?php foreach (ekl_rss_get_attribute_extractors() as $extractor => $label): ?>
            <option value="<?= $extractor; ?>" <?php if ($extractor === $entry_picture_attribute_extractor): ?>selected="selected"<?php endif; ?>><?= $label; ?></option>
          <?php endforeach; ?>
        </select>
      </td>
    </tr>
    <tr <?php if ($entry_picture_attribute_extractor !== 'regexp'): ?>style="display:none"<?php endif; ?> class="_check_ekl_rss_entry_picture_attribute_extractor _show_if_regexp">
      <td><label for="ekl_rss_entry_picture_extractor_expression"><?= __('Extractor regular expression:', 'ekl_rss_feed_reader'); ?></label></td>
      <td>
        <input type="text" id="ekl_rss_entry_picture_extractor_expression" name="ekl_rss_entry_picture_extractor_expression" value="<?= $entry_picture_extractor_expression; ?>" class="regular-text" />
        <span><?= __('without leading nor trailing slashes', 'ekl_rss_feed_reader'); ?></span>
      </td>
    </tr>
    <tr <?php if ($entry_picture_attribute_extractor !== 'regexp'): ?>style="display:none"<?php endif; ?> class="_check_ekl_rss_entry_picture_attribute_extractor _show_if_regexp">
      <td><label for="ekl_rss_entry_picture_extractor_payload"><?= __('Extractor payload index:', 'ekl_rss_feed_reader'); ?></label></td>
      <td><input type="text" id="ekl_rss_entry_picture_extractor_payload" name="ekl_rss_entry_picture_extractor_payload" value="<?= $entry_picture_extractor_payload; ?>" class="regular-text" /></td>
    </tr>
    <tr>
      <td><label for="ekl_rss_run_time"><?= __('Run on save', 'ekl_rss_feed_reader'); ?></label></td>
      <td>
        <select name="ekl_rss_run_on_save" id="ekl_rss_run_on_save">
          <option value="no" selected="selected"><?= __('No', 'ekl_rss_feed_reader'); ?></option>
          <option value="yes"><?= __('Yes', 'ekl_rss_feed_reader'); ?></option>
        </select>
      </td>
    </tr>
  </tbody>
</table>

<script type="text/javascript">
  (function () {
    var url_input                 = document.getElementById('ekl_rss_url');
    var url_input_error           = document.getElementById('ekl_rss_url_error');
    var check_url_button          = document.getElementById('ekl_rss_check_url_button');
    var check_url_spinner         = document.getElementById('ekl_rss_check_url_spinner');
    var picture_source_input      = document.getElementById('ekl_rss_entry_picture_source');
    var attribute_extractor_input = document.getElementById('ekl_rss_entry_picture_attribute_extractor');

    /**
     * Handles the change event for a master list which controls another element visibility
     *
     * @param {Object} event Event data
     *
     * @return {Void}
     */
    function onChangeMasterListInput(event) {
      // gets all nodex depending of this field
      document.querySelectorAll('._check_' + event.target.name).forEach(function (item) {
        // toggle item visibility according to expected value
        item.style.display = (item.classList.contains('_show_if_' + event.target.value)) ? null : 'none';
      });
    }

    /**
     * Handles the click over the button for check the URL
     *
     * @param {Object} event Event data
     *
     * @return {Void}
     */
    function onClickCheckUrlButton(event) {
      // clears the error container text
      url_input_error.innerText = '';

      // disables the URL field
      url_input.disabled = true;

      // disables the URL check button
      check_url_button.disabled = true;

      // shows the waiting animation
      check_url_spinner.classList.add('is-active');

      // requests the feed URL checking
      jQuery.post(
        '<?= admin_url('admin-ajax.php'); ?>',
        {
          url    : url_input.value,
          action : '<?= EKL_RSS_CHECK_URL_ACTION; ?>',
          nonce  : '<?= wp_create_nonce(EKL_RSS_CHECK_URL_ACTION); ?>'
        }
      )
        .fail(function (response) {
          var body = response.responseJSON || JSON.parse(response.responseText);
          var message = body.data ? body.data[0].message : 'Cannot check the URL';

          // shows the error message
          url_input_error.innerText = message;

          // there is a timeout for hidde field content
          if (url_input_error.dataset.hiddingTimeout) {
            // stops the field content hidding timeout
            clearTimeout(url_input_error.dataset.hiddingTimeout);
            url_input_error.dataset.hiddingTimeout = null;
          }

          // schedule the error hidding
          url_input_error.dataset.hiddingTimeout = setTimeout(
            function () {
              url_input_error.textContent            = '';
              url_input_error.dataset.hiddingTimeout = null;
            },
            10000
          );
        })
        .always(function () {
          // re-enables the URL field
          url_input.disabled = false;

          // re-enables the URL check button
          check_url_button.disabled = false;

          // hides the waiting animation
          check_url_spinner.classList.remove('is-active');

          // focus the URL input
          url_input.focus();
        });
    }

    /**
     * Handles the input event on the URL field
     *
     * @param {Object} event Event data
     *
     * @return {Void}
     */
    function onInputURLField(event) {
      check_url_button.disabled = ('' === url_input.value);
      url_input_error.innerText = '';
    }

    /**
     * Handles the keydown event on the URL field
     *
     * @param {Object} event Event data
     *
     * @return {Void}
     */
    function onKeydownURLField(event) {
      // it's the Enter key
      if (13 === event.keyCode) {
        event.stopPropagation();
        event.preventDefault();
        event.returnValue = false;

        // check URL button is enabled
        if (!check_url_button.disabled) {
          // calls the check URL action
          check_url_button.dispatchEvent(new Event('click'));
        }
      }
    }

    // adds the click event handler on the button for check the URL
    check_url_button.addEventListener('click', onClickCheckUrlButton);

    // adds the event handler on the URL field
    url_input.addEventListener('input', onInputURLField);
    url_input.addEventListener('keydown', onKeydownURLField)

    // adds the event handler for the picture source input
    picture_source_input.addEventListener('change', onChangeMasterListInput);

    // adds the event handler for the attribute extractor input
    attribute_extractor_input.addEventListener('change', onChangeMasterListInput);
  })();
</script>