<?php
// file is being called directly.
if (false === defined('ABSPATH')) {
  exit;
}
?>
<div class="wrap">
  <h1 class="wp-heading-inline"><?= __('Upgrade Actions', 'ekl_rss_feed_reader'); ?></h1>
  <table>
    <tbody>
      <tr>
        <td><label><?= __('Posts using old type:', 'ekl_rss_feed_reader'); ?></label></td>
        <td <?php if ($old_type_posts_count): ?>class="error-message"<?php endif; ?>><?= $old_type_posts_count; ?></td>
        <td>
          <button id="fix_old_type_posts_button" class="button" type="button" <?php if (0 === $old_type_posts_count): ?>disabled="disabled"<?php endif; ?>><?= __('Fix it', 'ekl_rss_feed_reader'); ?></button>
          <img src="<?= includes_url('images/spinner.gif'); ?>" alt="" class="spinner" id="ekl_fix_old_type_posts_spinner" />
        </td>
      </tr>
    </tbody>
  </table>
</div>
<script type="text/javascript">
  (function () {
    var fix_old_type_posts_button  = document.getElementById('fix_old_type_posts_button');
    var fix_old_type_posts_spinner = document.getElementById('ekl_fix_old_type_posts_spinner');

    /**
     * Method called when user clic on button to fix the old typed posts
     *
     * @param {Object} event Event data
     *
     * @return {Void}
     */
    function on_click_fix_old_type_posts_button(event) {
      // disables the button
      on_click_fix_old_type_posts_button.disabled = true;

      // shows the waiting animation
      fix_old_type_posts_spinner.classList.add('is-active');

      // requests the feed URL checking
      jQuery.post(
        '<?= admin_url('admin-ajax.php'); ?>',
        {
          action : '<?= EKL_RSS_UPDATE_OLD_TYPE_POSTS_ACTION; ?>',
          nonce  : '<?= wp_create_nonce(EKL_RSS_UPDATE_OLD_TYPE_POSTS_ACTION); ?>'
        }
      )
        .always(function () {
          // refresh the page
          location.reload();
        });
    }

    // sets the event handler for button to fix the old typed posts
    fix_old_type_posts_button.addEventListener('click', on_click_fix_old_type_posts_button);
  })();
</script>